package de.unisaar.jfap.ex6.monitor;

/**
 * Interface of products to be monitored with {@link Observer}s.
 *
 * @author Jörg Steffen, DFKI
 */
public interface Product {

  /**
   * Register given observer with this product.
   *
   * @param observer the observer to register
   */
  void register(Observer observer);

  /**
   * Unregister the given observer with this product.
   *
   * @param observer the observer to register
   */
  void unregister(Observer observer);

  /** Notify all observers of this product about a price change. */
  void notifyObservers();

  /** @return the price */
  int getPrice();
}
