package de.unisaar.jfap.ex6.operator;

/**
 * An operator that wraps a double so that it can be used as argument for other operators.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 */
public class Constant implements Operator {

  private double value;

  /**
   * Create a new constant with the given value.
   *
   * @param value the value as string
   */
  public Constant(String value) {
    this.value = Double.parseDouble(value);
  }

  @Override
  public double evaluate() {
    return this.value;
  }

  @Override
  public String toString() {
    return Double.toString(this.value);
  }
}
