package de.unisaar.jfap.ex6.operator;

/**
 * Common interface for all operators.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 */
public interface Operator {

  /**
   * Return the value of the evaluation of all subexpressions beyond this Operator node. For
   * Operators with arguments, that means that the arguments will have to be evaluated first (which
   * means recursive calls) and the appropriate operation will have to be executed on the results of
   * these evaluations.
   */
  double evaluate();
}
