package de.unisaar.jfap.ex6.operator;

/**
 * Abstract implementation of the {@link Operator} interface for unary operators. A unary operator
 * is applied to a single argument that is an operator itself.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 */
public abstract class UnaryOperator implements Operator {

  protected Operator arg;

  /**
   * Create a unary operator with the given argument.
   *
   * @param arg the argument
   */
  protected UnaryOperator(Operator arg) {
    this.arg = arg;
  }
}
