package de.unisaar.jfap.ex6.monitor;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

class MonitorTest {

  @Test
  void testMonitor() {

    Car car = new Car(17_500);
    PriceMonitor mon1 = new PriceMonitor(18_000);
    PriceMonitor mon2 = new PriceMonitor(17_000);
    PriceMonitor mon3 = new PriceMonitor(16_000);
    car.register(mon1);
    car.register(mon2);
    car.register(mon3);
    // notify observers after registering to catch immediate bargains
    car.notifyObservers();
    assertThat(mon1.isBargain()).isTrue();
    assertThat(mon2.isBargain()).isFalse();
    assertThat(mon3.isBargain()).isFalse();

    // change price to 16.500
    car.setPrice(16_500);
    assertThat(mon1.isBargain()).isTrue();
    assertThat(mon2.isBargain()).isTrue();
    assertThat(mon3.isBargain()).isFalse();

    // change price to 15.500
    car.setPrice(15_500);
    assertThat(mon1.isBargain()).isTrue();
    assertThat(mon2.isBargain()).isTrue();
    assertThat(mon3.isBargain()).isTrue();

    // change price to 19.000
    car.setPrice(19_000);
    assertThat(mon1.isBargain()).isFalse();
    assertThat(mon2.isBargain()).isFalse();
    assertThat(mon3.isBargain()).isFalse();

    car.unregister(mon1);
    car.unregister(mon2);
    car.unregister(mon3);
    // change price to 10.000
    car.setPrice(10_000);
    // monitors no longer recognize bargains
    assertThat(mon1.isBargain()).isFalse();
    assertThat(mon2.isBargain()).isFalse();
    assertThat(mon3.isBargain()).isFalse();


  }
}
